local config
local lfs = assert( love ).filesystem
local cfg = lfs.newFile "cfg.lua"

local mt = { __tostring = function( t ) 
    local arr = { "tblOption{\n  ",} 
    for k, v in pairs( t ) do
      arr[#arr + 1] = k
      arr[#arr + 1] = " = "
      arr[#arr + 1] = tostring( v )
      arr[#arr + 1] = ",\n  "
    end
    arr[#arr + 1] = "}"
    return table.concat( arr )
end }
local function tblOption(t)
  return setmetatable( t, mt )
end

local defaultConfig = {
  plName = "Player Name",
  plPronoun = tblOption{
    subject = "they",
    object = "them",
    possessive = "their",
  },
  plColour = tblOption{ 0.5, 0.6, 0.7, 0.5 },
  gamma = 0.5,
  keybinds = tblOption{
    Forward = "w",
    Back = "s",
    Left = "a",
    Right = "d",
    Chat = "t",
    Love = "q",
    Hate = "e",
  },
  serverIP = "192.168.2.15",
  serverPort = 51312,
  logFile = "log.txt",
}

local function readConfigFile()
  local ok, cfgTbl, err = pcall( lfs.load, 'cfg.lua' )
  if ok and cfgTbl then 
    local ok, err = pcall( cfgTbl )
    if err then print( "Failed to load settings file: ", err ) end
    return
  end
  return defaultConfig
end

local function dumpConfigFile()
  print( "Saving Settings." )
  assert( cfg:open 'w' )
  cfg:write( "return {\n " )
  for k, v in pairs( config ) do
    cfg:write( k )
    cfg:write( " = " )
    cfg:write( tostring( v ) )
    cfg:write( ",\n" )
  end
  cfg:write( "}" )
end

config = readConfigFile()

return config